
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// Lattice size parameter (now also hopping parameter)
//  is included, but it will be moved to other place).
#include "lattsize.h"

#include "field.h"

#include "linear_algebra.h"


#include "io_gauge.h"

#include "solv_wilson_ocl.h"


// local functions

void set_src(int ic, int id,
             int ix, int iy, int iz, int it, Field &b);



/* ****************************************************** */

int main(){

  Solv_Wilson solver;

  int nc2 = Ncol;

  printf("Simple Wilson solver\n\n");

  printf("Nx = %3d, Nx = %3d, Nx = %3d, Nx = %3d\n",
                                       Nx, Ny, Nz, Nt);
  printf("CKs = %10.6f\n", CKs);

  double enorm = 1.E-16;
  printf("enorm = %12.4e\n", enorm);
  double diff;
  int nconv;

  Field corr(Nt);
  corr.clear();


  Field xq(Nvst);
  Field bq(Nvst);
  // spinor field

  Field u(Ndf*Nst*4);
  // link variable

  printf("u read start\n");

  int istart = 3;
  uinit(istart, u);

  printf("u read end\n");
  printf("u[0] = %16.8e\n",u.e(0));

  printf("  ic  id   nconv      diff\n");

  for(int ic=0; ic<1; ic++){
    for(int id=0; id<1; id++){
     /*
  for(int ic=0; ic<Ncol; ic++){
   for(int id=0; id<ND; id++){
     */

    set_src(ic,id,0,0,0,0,bq);
    solver.solve_CG(enorm,nconv,diff,xq,u,bq);
    printf(" %3d %3d  %6d %12.4e\n", ic, id, nconv, diff);

    for(int it=0; it<Nt; it++){
      int Nvt = Nvc*ND*Nx*Ny*Nz;
      corr.e(it) += normp(Nvt,Nvt*it,xq);
    }

   }
  }

  printf("Ps meson correlator:\n");
  for(int it=0; it<Nt; it++){
    printf(" %6d   %16.8e\n", it, corr.e(it));
  }

}

/* ****************************************************** */
void set_src(int ic, int id,
              int ix, int iy, int iz, int it, Field &v){

  v.clear();

  int i = 2*ic + id*Nvc + Nvc*ND*(ix + iy*Nszx
                        + iz*Nszx*Nszy + it*Nszx*Nszy*Nszz);

  v.e(i) = 1.0;

}

/* ****************************************************** */
