#include <CL/cl.h>

typedef float real_t;


class Solv_Wilson{

 public:

  //! constructor
  Solv_Wilson(){
//      set_opencl();
  };

  //! destructor
  ~Solv_Wilson(){
//     fin_opencl();
  };

  void solve_CG(double enorm, int &nconv, double &diff,
		Field &fxq, Field &fu, Field &fb);

 protected:

  void solve_CG_init(double &rrp, double &rr, double *u,
		     double *x, double *r, double *s, double *p);

  void solve_CG_step(double &rrp, double &rr, double *u,
		     double *x, double *r, double *s, double *p);

  void set_f_from_a(Field &fv, double *v);

  void set_f_to_a(Field &fv, double *v);

  void opr_DdagD(double *v, double *u, double *w);

  void opr_D(double *v, double *u, double *w);

  void opr_H(double *v, double *u, double *w);

  void set_opencl();

  void fin_opencl();

  /* OpenCL variables  */
  cl_device_id      device_id;
  cl_context        context;
  cl_command_queue  command_queue;
  cl_program        program;
  cl_platform_id    platform_id;
  cl_uint  ret_num_devices;
  cl_uint  ret_num_platforms;
  cl_int   ret;

  cl_kernel         clmult_all;

};
